Subject: Re: reg. fatal: The remote end hung up unexpectedly on NFS

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Fri, 06 Apr 2018 20:46:21 +0200

On Fri, Apr 06 2018, Satya Prakash wrote:

> Hi,
>
> We have a distributed filesystem with NFS access. On the NFS mount, I
> was doing a git-clone and if NFS server crashed and came back up while
> the clone is going on, clone fails with the below message:
>
> git clone https://[email-masked]/fs/private-qa.git
>
> remote: Counting objects: 139419, done.
> remote: Compressing objects: 100% (504/504), done.
> Receiving objects:   7% (9760/139419), 5.32 MiB | 5.27 MiB/s
> error: RPC failed; result=18, HTTP code = 200 MiB | 96.00 KiB/s
> fatal: The remote end hung up unexpectedly
> fatal: early EOF
> fatal: index-pack failed
>[...]
> Please advise on how to debug this further.

I don't know what this could be, but have you tried turning on the
various GIT_TRACE env variables document in "man git"? Some of those
might hold a clue to what's going on here.

Have you tried to do other git-independent tests to see if in general
the NFS failover isn't resulting in data being written as applications
expect? E.g. doing a recursive wget of some data with known SHA1-sums,
or doing a stess test of some sort on a filesystem that uses checksums
(such as btrfs), which could be loop-mounted to a file stored on NFS.